searchData={"items":[{"type":"module","title":"Geminex.API.Private","doc":"Private API endpoints for Gemini.\n\nThis module provides functions to interact with Gemini's private REST API.\nEach function corresponds to a specific endpoint and handles the HTTP requests\nand responses, returning either **{:ok, result}** or **{:error, reason}**.\n\nThe base URL and API keys are determined by the **:environment**, **:api_key**, and **:api_secret**\nconfigurations in your application config.","ref":"Geminex.API.Private.html"},{"type":"module","title":"Configuration - Geminex.API.Private","doc":"Add the following to your **config/config.exs**:\n\n    config :geminex,\n      environment: :sandbox,\n      api_key: System.get_env(\"GEMINI_API_KEY\"),\n      api_secret: System.get_env(\"GEMINI_API_SECRET\")","ref":"Geminex.API.Private.html#module-configuration"},{"type":"function","title":"Geminex.API.Private.account_detail/1","doc":"Fetches account details, including user and account information.","ref":"Geminex.API.Private.html#account_detail/1"},{"type":"function","title":"Parameters - Geminex.API.Private.account_detail/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#account_detail/1-parameters"},{"type":"function","title":"Geminex.API.Private.account_margin/2","doc":"Retrieves margin details for a specific symbol.","ref":"Geminex.API.Private.html#account_margin/2"},{"type":"function","title":"Parameters - Geminex.API.Private.account_margin/2","doc":"- **symbol** (*String.t()*): The trading pair symbol (e.g., **\"BTC-GUSD-PERP\"**).\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account. This is required if using a master API key.","ref":"Geminex.API.Private.html#account_margin/2-parameters"},{"type":"function","title":"Geminex.API.Private.active_orders/1","doc":"Retrieves all active (live) orders associated with the account.","ref":"Geminex.API.Private.html#active_orders/1"},{"type":"function","title":"Parameters - Geminex.API.Private.active_orders/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#active_orders/1-parameters"},{"type":"function","title":"Geminex.API.Private.add_bank/5","doc":"Adds a bank account for the user.","ref":"Geminex.API.Private.html#add_bank/5"},{"type":"function","title":"Parameters - Geminex.API.Private.add_bank/5","doc":"- **account_number** (*String.t()*): Bank account number.\n  - **routing** (*String.t()*): Routing number.\n  - **type** (*String.t()*): Type of bank account, either **\"checking\"** or **\"savings\"**.\n  - **name** (*String.t()*): Name on the bank account.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#add_bank/5-parameters"},{"type":"function","title":"Geminex.API.Private.add_bank_cad/5","doc":"Adds a CAD bank account for the user.","ref":"Geminex.API.Private.html#add_bank_cad/5"},{"type":"function","title":"Parameters - Geminex.API.Private.add_bank_cad/5","doc":"- **swift_code** (*String.t()*): SWIFT code.\n  - **account_number** (*String.t()*): Bank account number.\n  - **type** (*String.t()*): Type of bank account, either \"checking\" or \"savings\".\n  - **name** (*String.t()*): Name on the bank account.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:institution_number** (*String.t()*): Institution number of the account.\n    - **:branch_number** (*String.t()*): Branch number of the account.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#add_bank_cad/5-parameters"},{"type":"function","title":"Geminex.API.Private.available_balances/1","doc":"Fetches available balances in supported currencies.","ref":"Geminex.API.Private.html#available_balances/1"},{"type":"function","title":"Parameters - Geminex.API.Private.available_balances/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#available_balances/1-parameters"},{"type":"function","title":"Geminex.API.Private.cancel_all_active_orders/1","doc":"Cancels all outstanding orders created by any session associated with this account, including those placed via the UI.\n\nGenerally, it is recommended to use **cancel_all_session_orders** to only cancel orders related to the current session.","ref":"Geminex.API.Private.html#cancel_all_active_orders/1"},{"type":"function","title":"Parameters - Geminex.API.Private.cancel_all_active_orders/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#cancel_all_active_orders/1-parameters"},{"type":"function","title":"Geminex.API.Private.cancel_all_session_orders/1","doc":"Cancels all orders opened by this session.\n\nIf \"Require Heartbeat\" is enabled for the session, this function behaves as a heartbeat expiration.","ref":"Geminex.API.Private.html#cancel_all_session_orders/1"},{"type":"function","title":"Parameters - Geminex.API.Private.cancel_all_session_orders/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#cancel_all_session_orders/1-parameters"},{"type":"function","title":"Geminex.API.Private.cancel_clearing_order/2","doc":"Cancels a specific clearing order.","ref":"Geminex.API.Private.html#cancel_clearing_order/2"},{"type":"function","title":"Parameters - Geminex.API.Private.cancel_clearing_order/2","doc":"- **clearing_id**: The unique identifier of the clearing order.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#cancel_clearing_order/2-parameters"},{"type":"function","title":"Geminex.API.Private.cancel_order/2","doc":"Cancels an existing order by order ID.","ref":"Geminex.API.Private.html#cancel_order/2"},{"type":"function","title":"Parameters - Geminex.API.Private.cancel_order/2","doc":"- **order_id** (*non_neg_integer()*): The ID of the order to cancel.\n  - **opts** (*keyword list, optional*): A list of additional options.\n    - **:account** (*String.t()*): Specifies the name of the account within the subaccount group. This is required if using a Master API key.","ref":"Geminex.API.Private.html#cancel_order/2-parameters"},{"type":"function","title":"Behavior - Geminex.API.Private.cancel_order/2","doc":"If the order has already been canceled, this request will succeed but have no effect. The order status will remain unchanged.","ref":"Geminex.API.Private.html#cancel_order/2-behavior"},{"type":"function","title":"Returns - Geminex.API.Private.cancel_order/2","doc":"- **{:ok, map}** on success, containing the response details of the canceled order.\n  - **{:error, any}** on failure, with an error reason.","ref":"Geminex.API.Private.html#cancel_order/2-returns"},{"type":"function","title":"Geminex.API.Private.clearing_broker_list/1","doc":"Retrieves a list of broker clearing orders with optional filters.","ref":"Geminex.API.Private.html#clearing_broker_list/1"},{"type":"function","title":"Parameters - Geminex.API.Private.clearing_broker_list/1","doc":"- **opts** (*keyword list, optional*): Filter options for broker clearing orders.\n    - **:symbol** (*String.t()*): Trading pair symbol.\n    - **:expiration_start** (*non_neg_integer()*): Start timestamp for expiration filter.\n    - **:expiration_end** (*non_neg_integer()*): End timestamp for expiration filter.\n    - **:submission_start** (*non_neg_integer()*): Start timestamp for submission filter.\n    - **:submission_end** (*non_neg_integer()*): End timestamp for submission filter.\n    - **:funded** (*boolean()*): Whether the order is funded.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#clearing_broker_list/1-parameters"},{"type":"function","title":"Geminex.API.Private.clearing_order_list/2","doc":"Retrieves a list of clearing orders with optional filters.","ref":"Geminex.API.Private.html#clearing_order_list/2"},{"type":"function","title":"Parameters - Geminex.API.Private.clearing_order_list/2","doc":"- **side** (*String.t()*): \"buy\" or \"sell\" (required).\n  - **opts** (*keyword list, optional*): Filter options for the clearing orders.\n    - **:symbol** (*String.t()*): Trading pair symbol.\n    - **:counterparty** (*String.t()*): Counterparty ID or alias.\n    - **:expiration_start** (*non_neg_integer()*): Start timestamp for expiration filter.\n    - **:expiration_end** (*non_neg_integer()*): End timestamp for expiration filter.\n    - **:submission_start** (*non_neg_integer()*): Start timestamp for submission filter.\n    - **:submission_end** (*non_neg_integer()*): End timestamp for submission filter.\n    - **:funded** (*boolean()*): Whether the order is funded.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#clearing_order_list/2-parameters"},{"type":"function","title":"Geminex.API.Private.clearing_order_status/2","doc":"Fetches the status of a clearing order by its unique clearing ID.","ref":"Geminex.API.Private.html#clearing_order_status/2"},{"type":"function","title":"Parameters - Geminex.API.Private.clearing_order_status/2","doc":"- **clearing_id**: A unique identifier for the clearing order.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#clearing_order_status/2-parameters"},{"type":"function","title":"Geminex.API.Private.clearing_trades/1","doc":"Retrieves a list of clearing trades with optional filters.","ref":"Geminex.API.Private.html#clearing_trades/1"},{"type":"function","title":"Parameters - Geminex.API.Private.clearing_trades/1","doc":"- **opts** (*keyword list, optional*): Filter options for clearing trades.\n    - **:timestamp_nanos** (*non_neg_integer()*): Only return trades on or after this timestamp in nanoseconds.\n    - **:limit** (*non_neg_integer()*): The maximum number of trades to return.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#clearing_trades/1-parameters"},{"type":"function","title":"Geminex.API.Private.confirm_clearing_order/6","doc":"Confirms a clearing order with the provided details.","ref":"Geminex.API.Private.html#confirm_clearing_order/6"},{"type":"function","title":"Parameters - Geminex.API.Private.confirm_clearing_order/6","doc":"- **clearing_id**: The unique identifier of the clearing order.\n  - **symbol**: The trading pair symbol.\n  - **amount**: The amount to purchase as a string.\n  - **price**: The price per unit as a string.\n  - **side**: \"buy\" or \"sell\".\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#confirm_clearing_order/6-parameters"},{"type":"function","title":"Geminex.API.Private.create_account/2","doc":"Creates a new account within the master group.","ref":"Geminex.API.Private.html#create_account/2"},{"type":"function","title":"Parameters - Geminex.API.Private.create_account/2","doc":"- **name** (*String.t()*): A unique name for the new account.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:type** (*String.t()*): Type of account. Accepts **\"exchange\"** or **\"custody\"**. Defaults to **\"exchange\"**.","ref":"Geminex.API.Private.html#create_account/2-parameters"},{"type":"function","title":"Geminex.API.Private.create_address_request/4","doc":"Creates a request to add an address to the approved address list.","ref":"Geminex.API.Private.html#create_address_request/4"},{"type":"function","title":"Parameters - Geminex.API.Private.create_address_request/4","doc":"- **network** (*String.t()*): The network for the address, e.g., \"ethereum\", \"bitcoin\".\n  - **address** (*String.t()*): The address to add to the approved address list.\n  - **label** (*String.t()*): The label for the approved address.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.\n    - **:memo** (*String.t()*): Memo for specific address formats, e.g., Cosmos.","ref":"Geminex.API.Private.html#create_address_request/4-parameters"},{"type":"function","title":"Geminex.API.Private.custody_account_fees/1","doc":"Fetches custody account fees.","ref":"Geminex.API.Private.html#custody_account_fees/1"},{"type":"function","title":"Parameters - Geminex.API.Private.custody_account_fees/1","doc":"- **opts** (*keyword list, optional*): Options for filtering custody fees.\n    - **:timestamp** (*non_neg_integer()*): Only return Custody fee records on or after this timestamp.\n    - **:limit_transfers** (*non_neg_integer()*): The maximum number of Custody fee records to return.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#custody_account_fees/1-parameters"},{"type":"function","title":"Geminex.API.Private.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#delete/3"},{"type":"function","title":"Geminex.API.Private.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#delete!/3"},{"type":"function","title":"Geminex.API.Private.deposit_addresses/2","doc":"Retrieves deposit addresses for a specified network.","ref":"Geminex.API.Private.html#deposit_addresses/2"},{"type":"function","title":"Parameters - Geminex.API.Private.deposit_addresses/2","doc":"- **network** (*String.t()*): Cryptocurrency network (e.g., \"bitcoin\", \"ethereum\").\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:timestamp** (*non_neg_integer()*): Only return addresses created on or after this timestamp.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#deposit_addresses/2-parameters"},{"type":"function","title":"Geminex.API.Private.estimate_gas_fee/4","doc":"Estimates gas fees for a cryptocurrency withdrawal.","ref":"Geminex.API.Private.html#estimate_gas_fee/4"},{"type":"function","title":"Parameters - Geminex.API.Private.estimate_gas_fee/4","doc":"- **currency** (*String.t()*): The cryptocurrency code (e.g., \"eth\").\n  - **address** (*String.t()*): Destination cryptocurrency address.\n  - **amount** (*String.t()*): The amount to withdraw.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#estimate_gas_fee/4-parameters"},{"type":"function","title":"Geminex.API.Private.execute_internal_transfer/5","doc":"Executes an internal transfer between two accounts.","ref":"Geminex.API.Private.html#execute_internal_transfer/5"},{"type":"function","title":"Parameters - Geminex.API.Private.execute_internal_transfer/5","doc":"- **currency** (*String.t()*): Currency code (e.g., \"btc\").\n  - **source_account** (*String.t()*): The account to transfer funds from.\n  - **target_account** (*String.t()*): The account to transfer funds to.\n  - **amount** (*String.t()*): The amount to transfer.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:client_transfer_id** (*String.t()*): Unique identifier for the transfer.","ref":"Geminex.API.Private.html#execute_internal_transfer/5-parameters"},{"type":"function","title":"Geminex.API.Private.funding_payment/1","doc":"Retrieves funding payment history within a specified time range.","ref":"Geminex.API.Private.html#funding_payment/1"},{"type":"function","title":"Parameters - Geminex.API.Private.funding_payment/1","doc":"- **opts** (*keyword list, optional*): Options to customize the funding payment query.\n    - **:since** (*non_neg_integer()*): The starting timestamp for the funding payments.\n    - **:to** (*non_neg_integer()*): The ending timestamp for the funding payments.\n    - **:account** (*String.t()*): Specifies the sub-account. This is required if using a master API key.","ref":"Geminex.API.Private.html#funding_payment/1-parameters"},{"type":"function","title":"Geminex.API.Private.funding_payment_report_file/1","doc":"Retrieves funding payment data as an Excel file for a specified date range and row limit.","ref":"Geminex.API.Private.html#funding_payment_report_file/1"},{"type":"function","title":"Parameters - Geminex.API.Private.funding_payment_report_file/1","doc":"- **opts** (*keyword list, optional*): Options to customize the data retrieval.\n    - **:from_date** (*String.t()*): Start date for the records in **YYYY-MM-DD** format.\n    - **:to_date** (*String.t()*): End date for the records in **YYYY-MM-DD** format.\n    - **:num_rows** (*non_neg_integer()*): Maximum number of rows to retrieve (default 8760).","ref":"Geminex.API.Private.html#funding_payment_report_file/1-parameters"},{"type":"function","title":"Geminex.API.Private.funding_payment_report_json/1","doc":"Retrieves funding payment data as JSON for a specified date range and row limit.","ref":"Geminex.API.Private.html#funding_payment_report_json/1"},{"type":"function","title":"Parameters - Geminex.API.Private.funding_payment_report_json/1","doc":"- **opts** (*keyword list, optional*): Options to customize the data retrieval.\n    - **:from_date** (*String.t()*): Start date for the records in **YYYY-MM-DD** format.\n    - **:to_date** (*String.t()*): End date for the records in **YYYY-MM-DD** format.\n    - **:num_rows** (*non_neg_integer()*): Maximum number of rows to retrieve (default 8760).","ref":"Geminex.API.Private.html#funding_payment_report_json/1-parameters"},{"type":"function","title":"Geminex.API.Private.fx_rate/2","doc":"Retrieves the historical FX rate for a specific currency pair against USD at a given timestamp.","ref":"Geminex.API.Private.html#fx_rate/2"},{"type":"function","title":"Parameters - Geminex.API.Private.fx_rate/2","doc":"- **symbol**: The currency pair symbol to check the USD FX rate against (e.g., \"gbpusd\").\n  - **timestamp**: The timestamp (in epoch format) for which the FX rate is requested.","ref":"Geminex.API.Private.html#fx_rate/2-parameters"},{"type":"function","title":"Geminex.API.Private.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#get/3"},{"type":"function","title":"Geminex.API.Private.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#get!/3"},{"type":"function","title":"Geminex.API.Private.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#head/3"},{"type":"function","title":"Geminex.API.Private.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#head!/3"},{"type":"function","title":"Geminex.API.Private.heartbeat/0","doc":"Sends a heartbeat to prevent session timeout when the require heartbeat flag is set.","ref":"Geminex.API.Private.html#heartbeat/0"},{"type":"function","title":"Geminex.API.Private.list_accounts/1","doc":"Fetches a list of accounts within the master group.","ref":"Geminex.API.Private.html#list_accounts/1"},{"type":"function","title":"Parameters - Geminex.API.Private.list_accounts/1","doc":"- **opts** (*keyword list, optional*): Options for filtering the account list.\n    - **:limit_accounts** (*non_neg_integer()*): Max number of accounts to return. Default is 500.\n    - **:timestamp** (*non_neg_integer()*): Only return accounts created on or before this timestamp.","ref":"Geminex.API.Private.html#list_accounts/1-parameters"},{"type":"function","title":"Geminex.API.Private.new_broker_order/7","doc":"Creates a new broker clearing order between two counterparties.","ref":"Geminex.API.Private.html#new_broker_order/7"},{"type":"function","title":"Parameters - Geminex.API.Private.new_broker_order/7","doc":"- **symbol** (*String.t()*): The trading pair symbol.\n  - **amount** (*String.t()*): The amount to purchase as a string.\n  - **price** (*String.t()*): The price per unit as a string.\n  - **side** (*String.t()*): **\"buy\"** or **\"sell\"**.\n  - **source_counterparty_id** (*String.t()*): The counterparty initiating the trade.\n  - **target_counterparty_id** (*String.t()*): The target counterparty.\n  - **opts** (*keyword list, optional*): Additional options for the broker order.\n    - **:expires_in_hrs** (*non_neg_integer()*): Number of hours before the trade expires.\n    - **:account** (*String.t()*): Specifies the broker sub-account.","ref":"Geminex.API.Private.html#new_broker_order/7-parameters"},{"type":"function","title":"Geminex.API.Private.new_clearing_order/5","doc":"Creates a new clearing order with optional counterparty and expiration details.","ref":"Geminex.API.Private.html#new_clearing_order/5"},{"type":"function","title":"Parameters - Geminex.API.Private.new_clearing_order/5","doc":"- **symbol** (*String.t()*): The trading pair symbol for the order (e.g., **\"btcusd\"**).\n  - **amount** (*String.t()*): The amount to purchase as a string.\n  - **price** (*String.t()*): The price per unit as a string.\n  - **side** (*String.t()*): **\"buy\"** or **\"sell\"**.\n  - **opts** (*keyword list, optional*): Additional options for the clearing order.\n    - **:counterparty_id** (*String.t()*): ID of the counterparty for this trade.\n    - **:expires_in_hrs** (*non_neg_integer()*): Number of hours before the trade expires.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#new_clearing_order/5-parameters"},{"type":"function","title":"Geminex.API.Private.new_deposit_address/2","doc":"Generates a new deposit address for a specified network.","ref":"Geminex.API.Private.html#new_deposit_address/2"},{"type":"function","title":"Parameters - Geminex.API.Private.new_deposit_address/2","doc":"- **network** (*String.t()*): Cryptocurrency network (e.g., \"bitcoin\", \"litecoin\").\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:label** (*String.t()*): Label for the deposit address.\n    - **:legacy** (*boolean()*): Whether to generate a legacy P2SH-P2PKH litecoin address.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#new_deposit_address/2-parameters"},{"type":"function","title":"Geminex.API.Private.new_order/6","doc":"Places a new order with specified parameters and optional settings.","ref":"Geminex.API.Private.html#new_order/6"},{"type":"function","title":"Parameters - Geminex.API.Private.new_order/6","doc":"- **symbol** (*String.t()*): The trading pair symbol (e.g., **\"btcusd\"**).\n  - **amount** (*String.t()*): The amount to purchase as a string.\n  - **price** (*String.t()*): The limit price per unit as a string.\n  - **side** (*String.t()*): Order side, either **\"buy\"** or **\"sell\"**.\n  - **type** (*String.t()*): Order type, e.g., **\"exchange limit\"** or **\"exchange stop limit\"**.\n  - **opts** (*keyword list, optional*): Optional settings for the order.\n    - **:client_order_id** (*String.t()*): A custom client ID for the order.\n    - **:stop_price** (*String.t()*): The stop price for stop-limit orders.\n    - **:options** (*list(String.t())*): List of order execution options (e.g., **[\"maker-or-cancel\"]**).\n    - **:account** (*String.t()*): Specifies the sub-account (required for master API keys).","ref":"Geminex.API.Private.html#new_order/6-parameters"},{"type":"function","title":"Returns - Geminex.API.Private.new_order/6","doc":"- **{:ok, map}** on success, containing order details.\n  - **{:error, any}** on failure, with an error reason.","ref":"Geminex.API.Private.html#new_order/6-returns"},{"type":"function","title":"Geminex.API.Private.notional_balances/2","doc":"Fetches balances and their notional values in a specified currency.","ref":"Geminex.API.Private.html#notional_balances/2"},{"type":"function","title":"Parameters - Geminex.API.Private.notional_balances/2","doc":"- **currency** (*String.t()*): Three-letter fiat currency code for notional values (e.g., \"usd\").\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#notional_balances/2-parameters"},{"type":"function","title":"Geminex.API.Private.notional_volume/1","doc":"Retrieves the 30-day notional volume and fee details for the account.","ref":"Geminex.API.Private.html#notional_volume/1"},{"type":"function","title":"Parameters - Geminex.API.Private.notional_volume/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:symbol** (*String.t()*): The participating symbol for fee promotions (e.g., \"btcusd\").\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#notional_volume/1-parameters"},{"type":"function","title":"Geminex.API.Private.open_positions/1","doc":"Retrieves all open positions for the account.","ref":"Geminex.API.Private.html#open_positions/1"},{"type":"function","title":"Parameters - Geminex.API.Private.open_positions/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account. This is required if using a master API key.","ref":"Geminex.API.Private.html#open_positions/1-parameters"},{"type":"function","title":"Geminex.API.Private.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#options/3"},{"type":"function","title":"Geminex.API.Private.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#options!/3"},{"type":"function","title":"Geminex.API.Private.order_status/1","doc":"Retrieves the status of a specific order, identified by either **order_id** or **client_order_id**.","ref":"Geminex.API.Private.html#order_status/1"},{"type":"function","title":"Parameters - Geminex.API.Private.order_status/1","doc":"- **opts** (*keyword list, optional*): Options for specifying order details.\n    - **:order_id** (*non_neg_integer()*): The order ID to retrieve status for. Cannot be used with **client_order_id**.\n    - **:client_order_id** (*String.t()*): The client-specified order ID used during order placement. Cannot be used with **order_id**.\n    - **:include_trades** (*boolean()*): If **true**, includes trade details for all fills associated with the order.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#order_status/1-parameters"},{"type":"function","title":"Geminex.API.Private.orders_history/1","doc":"Retrieves a history of closed orders for a specific symbol.","ref":"Geminex.API.Private.html#orders_history/1"},{"type":"function","title":"Parameters - Geminex.API.Private.orders_history/1","doc":"- **opts** (*keyword list, optional*): Options to customize the order retrieval.\n    - **:symbol** (*String.t()*): The symbol to retrieve orders for (e.g., \"btcusd\").\n    - **:limit_orders** (*non_neg_integer()*): Maximum number of orders to return (default 50, max 500).\n    - **:timestamp** (*non_neg_integer()*): Only return orders on or after this timestamp.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#orders_history/1-parameters"},{"type":"function","title":"Geminex.API.Private.past_trades/1","doc":"Retrieves past trades for a specific symbol.","ref":"Geminex.API.Private.html#past_trades/1"},{"type":"function","title":"Parameters - Geminex.API.Private.past_trades/1","doc":"- **opts** (*keyword list, optional*): Options to customize the trade retrieval.\n    - **:symbol** (*String.t()*): The symbol to retrieve trades for (e.g., \"btcusd\").\n    - **:limit_trades** (*non_neg_integer()*): Maximum number of trades to return (default 50, max 500).\n    - **:timestamp** (*non_neg_integer()*): Only return trades on or after this timestamp.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.","ref":"Geminex.API.Private.html#past_trades/1-parameters"},{"type":"function","title":"Geminex.API.Private.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Private.html#patch/4"},{"type":"function","title":"Geminex.API.Private.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Private.html#patch!/4"},{"type":"function","title":"Geminex.API.Private.payment_methods/1","doc":"Fetches payment methods and available fiat balances.","ref":"Geminex.API.Private.html#payment_methods/1"},{"type":"function","title":"Parameters - Geminex.API.Private.payment_methods/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#payment_methods/1-parameters"},{"type":"function","title":"Geminex.API.Private.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Private.html#post/4"},{"type":"function","title":"Geminex.API.Private.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Private.html#post!/4"},{"type":"function","title":"Geminex.API.Private.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Private.html#put/4"},{"type":"function","title":"Geminex.API.Private.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Private.html#put!/4"},{"type":"function","title":"Geminex.API.Private.remove_address/3","doc":"Removes an address from the approved address list.","ref":"Geminex.API.Private.html#remove_address/3"},{"type":"function","title":"Parameters - Geminex.API.Private.remove_address/3","doc":"- **network** (*String.t()*): The network for the address, e.g., \"ethereum\".\n  - **address** (*String.t()*): The address to remove from the approved address list.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#remove_address/3-parameters"},{"type":"function","title":"Geminex.API.Private.rename_account/2","doc":"Renames an account within the master group.","ref":"Geminex.API.Private.html#rename_account/2"},{"type":"function","title":"Parameters - Geminex.API.Private.rename_account/2","doc":"- **account** (*String.t()*): Short name of the existing account.\n  - **opts** (*keyword list, optional*): Additional options for renaming the account.\n    - **:new_name** (*String.t()*): New unique name for the account.\n    - **:new_account** (*String.t()*): New unique short name for the account.","ref":"Geminex.API.Private.html#rename_account/2-parameters"},{"type":"function","title":"Geminex.API.Private.request/2","doc":"Perform a request.","ref":"Geminex.API.Private.html#request/2"},{"type":"function","title":"Options - Geminex.API.Private.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"Geminex.API.Private.html#request/2-options"},{"type":"function","title":"Examples - Geminex.API.Private.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"Geminex.API.Private.html#request/2-examples"},{"type":"function","title":"Geminex.API.Private.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"Geminex.API.Private.html#request!/2"},{"type":"function","title":"Geminex.API.Private.risk_stats/1","doc":"Retrieves risk statistics for a specified symbol.","ref":"Geminex.API.Private.html#risk_stats/1"},{"type":"function","title":"Parameters - Geminex.API.Private.risk_stats/1","doc":"- **symbol** (*String.t()*): The trading pair symbol (e.g., **\"BTCGUSDPERP\"**).","ref":"Geminex.API.Private.html#risk_stats/1-parameters"},{"type":"function","title":"Geminex.API.Private.stake/4","doc":"Initiates a staking deposit.","ref":"Geminex.API.Private.html#stake/4"},{"type":"function","title":"Parameters - Geminex.API.Private.stake/4","doc":"- **provider_id** (*String.t()*): The provider ID in UUID4 format.\n  - **currency** (*String.t()*): The currency to deposit, e.g., \"ETH\".\n  - **amount** (*String.t()*): Amount of currency to deposit.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#stake/4-parameters"},{"type":"function","title":"Geminex.API.Private.staking_balances/1","doc":"Retrieves the staking balances for the account.","ref":"Geminex.API.Private.html#staking_balances/1"},{"type":"function","title":"Parameters - Geminex.API.Private.staking_balances/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#staking_balances/1-parameters"},{"type":"function","title":"Geminex.API.Private.staking_history/1","doc":"Retrieves staking transaction history, including deposits, redemptions, and interest accruals.","ref":"Geminex.API.Private.html#staking_history/1"},{"type":"function","title":"Parameters - Geminex.API.Private.staking_history/1","doc":"- **opts** (*keyword list, optional*): Options for filtering staking history.\n    - **:since** (*String.t()*): Start date in ISO datetime format.\n    - **:until** (*String.t()*): End date in ISO datetime format, defaults to the current time.\n    - **:limit** (*non_neg_integer()*): Max number of transactions to return.\n    - **:provider_id** (*String.t()*): ID of the provider.\n    - **:currency** (*String.t()*): Currency code, e.g., \"ETH\".\n    - **:interest_only** (*boolean()*): Set to true to only return daily interest transactions.\n    - **:sort_asc** (*boolean()*): Set to true to sort transactions in ascending order.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#staking_history/1-parameters"},{"type":"function","title":"Geminex.API.Private.staking_rates/0","doc":"Fetches current staking interest rates for specified assets or all assets if no specific asset is provided.","ref":"Geminex.API.Private.html#staking_rates/0"},{"type":"function","title":"Geminex.API.Private.staking_rewards/2","doc":"Retrieves staking rewards, showing historical payments and accrual data.","ref":"Geminex.API.Private.html#staking_rewards/2"},{"type":"function","title":"Parameters - Geminex.API.Private.staking_rewards/2","doc":"- **since** (*String.t()*): Start date in ISO datetime format.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:until** (*String.t()*): End date in ISO datetime format. Defaults to the current time.\n    - **:provider_id** (*String.t()*): ID of the provider.\n    - **:currency** (*String.t()*): Currency code, e.g., \"ETH\".\n    - **:account** (*String.t()*): Specifies the sub-account (required for Master API keys).","ref":"Geminex.API.Private.html#staking_rewards/2-parameters"},{"type":"function","title":"Geminex.API.Private.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#trace/3"},{"type":"function","title":"Geminex.API.Private.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Private.html#trace!/3"},{"type":"function","title":"Geminex.API.Private.trade_volume/1","doc":"Retrieves the trade volume data for the account over the past 30 days.","ref":"Geminex.API.Private.html#trade_volume/1"},{"type":"function","title":"Parameters - Geminex.API.Private.trade_volume/1","doc":"- **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account. This is required if using a master API key.","ref":"Geminex.API.Private.html#trade_volume/1-parameters"},{"type":"function","title":"Geminex.API.Private.transactions/1","doc":"Fetches transaction details, including trades and transfers.","ref":"Geminex.API.Private.html#transactions/1"},{"type":"function","title":"Parameters - Geminex.API.Private.transactions/1","doc":"- **opts** (*keyword list, optional*): Options for filtering transactions.\n    - **:timestamp_nanos** (*non_neg_integer()*): Only return transactions on or after this timestamp in nanoseconds.\n    - **:limit** (*non_neg_integer()*): Maximum number of transactions to return (default is 100).\n    - **:continuation_token** (*String.t()*): Token for pagination in subsequent requests.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#transactions/1-parameters"},{"type":"function","title":"Geminex.API.Private.transfers/1","doc":"Retrieves transfer history, including deposits and withdrawals.","ref":"Geminex.API.Private.html#transfers/1"},{"type":"function","title":"Parameters - Geminex.API.Private.transfers/1","doc":"- **opts** (*keyword list, optional*): Options for filtering transfers.\n    - **:currency** (*String.t()*): Currency code to filter transfers.\n    - **:timestamp** (*non_neg_integer()*): Only return transfers on or after this timestamp.\n    - **:limit_transfers** (*non_neg_integer()*): Maximum number of transfers to return.\n    - **:show_completed_deposit_advances** (*boolean()*): Whether to show completed deposit advances.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#transfers/1-parameters"},{"type":"function","title":"Geminex.API.Private.unstake/4","doc":"Initiates a staking withdrawal.","ref":"Geminex.API.Private.html#unstake/4"},{"type":"function","title":"Parameters - Geminex.API.Private.unstake/4","doc":"- **provider_id** (*String.t()*): The provider ID in UUID4 format.\n  - **currency** (*String.t()*): The currency to withdraw, e.g., \"ETH\".\n  - **amount** (*String.t()*): Amount of currency to withdraw.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#unstake/4-parameters"},{"type":"function","title":"Geminex.API.Private.view_approved_addresses/2","doc":"Views the approved address list for a specific network.","ref":"Geminex.API.Private.html#view_approved_addresses/2"},{"type":"function","title":"Parameters - Geminex.API.Private.view_approved_addresses/2","doc":"- **network** (*String.t()*): The network to view the approved address list for, e.g., \"ethereum\".\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#view_approved_addresses/2-parameters"},{"type":"function","title":"Geminex.API.Private.withdraw_crypto_funds/4","doc":"Withdraws cryptocurrency funds to an approved address.","ref":"Geminex.API.Private.html#withdraw_crypto_funds/4"},{"type":"function","title":"Parameters - Geminex.API.Private.withdraw_crypto_funds/4","doc":"- **currency** (*String.t()*): The cryptocurrency code (e.g., \"btc\").\n  - **address** (*String.t()*): The destination cryptocurrency address.\n  - **amount** (*String.t()*): The amount to withdraw.\n  - **opts** (*keyword list, optional*): Additional options.\n    - **:client_transfer_id** (*String.t()*): Unique identifier for the withdrawal.\n    - **:memo** (*String.t()*): Memo for addresses requiring it.\n    - **:account** (*String.t()*): Specifies the sub-account.","ref":"Geminex.API.Private.html#withdraw_crypto_funds/4-parameters"},{"type":"function","title":"Geminex.API.Private.wrap_order/4","doc":"Wraps or unwraps Gemini-issued assets.","ref":"Geminex.API.Private.html#wrap_order/4"},{"type":"function","title":"Parameters - Geminex.API.Private.wrap_order/4","doc":"- **symbol** (*String.t()*): The trading pair symbol for the asset to be wrapped or unwrapped (e.g., **\"GUSDUSD\"**).\n  - **amount** (*String.t()*): The amount to be wrapped or unwrapped, specified as a string.\n  - **side** (*String.t()*): The direction of the transaction, either **\"buy\"** (to wrap) or **\"sell\"** (to unwrap).\n  - **opts** (*keyword list, optional*): Additional options for the transaction.\n    - **:account** (*String.t()*): Specifies the sub-account, required if using a master API key.\n    - **:client_order_id** (*String.t()*): A custom client ID for tracking the order.","ref":"Geminex.API.Private.html#wrap_order/4-parameters"},{"type":"function","title":"Returns - Geminex.API.Private.wrap_order/4","doc":"- **{:ok, map}** on success, containing details of the wrap or unwrap transaction.\n  - **{:error, any}** on failure, with an error reason.","ref":"Geminex.API.Private.html#wrap_order/4-returns"},{"type":"type","title":"Geminex.API.Private.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"Geminex.API.Private.html#t:option/0"},{"type":"module","title":"Geminex.API.Public","doc":"Public API endpoints for Gemini.","ref":"Geminex.API.Public.html"},{"type":"function","title":"Geminex.API.Public.candles/2","doc":"Retrieves time-intervaled data for the provided symbol.","ref":"Geminex.API.Public.html#candles/2"},{"type":"function","title":"Parameters - Geminex.API.Public.candles/2","doc":"- **symbol**: Trading pair symbol (e.g., \"btcusd\").\n  - **time_frame**: Time range for each candle (e.g., \"1m\", \"5m\").","ref":"Geminex.API.Public.html#candles/2-parameters"},{"type":"function","title":"Geminex.API.Public.current_order_book/2","doc":"Retrieves the current order book for the specified trading pair symbol.","ref":"Geminex.API.Public.html#current_order_book/2"},{"type":"function","title":"Parameters - Geminex.API.Public.current_order_book/2","doc":"- **symbol** (*String.t()*): The trading pair symbol (e.g., **\"btcusd\"**).\n  - **opts** (*keyword list, optional*): A list of query parameters to customize the order book data.\n    - **:limit_bids** (*non_neg_integer()*): The maximum number of bid orders to retrieve.\n    - **:limit_asks** (*non_neg_integer()*): The maximum number of ask orders to retrieve.","ref":"Geminex.API.Public.html#current_order_book/2-parameters"},{"type":"function","title":"Returns - Geminex.API.Public.current_order_book/2","doc":"- **{:ok, map}** on success, containing the order book data as a map.\n  - **{:error, any}** on failure, with an error reason.","ref":"Geminex.API.Public.html#current_order_book/2-returns"},{"type":"function","title":"Geminex.API.Public.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#delete/3"},{"type":"function","title":"Geminex.API.Public.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#delete!/3"},{"type":"function","title":"Geminex.API.Public.derivatives_candles/2","doc":"Retrieves time-intervaled data for the provided perpetual swap symbol.","ref":"Geminex.API.Public.html#derivatives_candles/2"},{"type":"function","title":"Parameters - Geminex.API.Public.derivatives_candles/2","doc":"- **symbol**: Perpetual swap symbol (e.g., \"BTCGUSDPERP\").\n  - **time_frame**: Time range for each candle (e.g., \"1m\").","ref":"Geminex.API.Public.html#derivatives_candles/2-parameters"},{"type":"function","title":"Geminex.API.Public.fee_promos/0","doc":"Retrieves symbols that currently have fee promos.","ref":"Geminex.API.Public.html#fee_promos/0"},{"type":"function","title":"Geminex.API.Public.funding_amount/1","doc":"Retrieves the funding amount details for the specified symbol.","ref":"Geminex.API.Public.html#funding_amount/1"},{"type":"function","title":"Parameters - Geminex.API.Public.funding_amount/1","doc":"- **symbol**: Trading pair symbol (e.g., \"btcgusdperp\").","ref":"Geminex.API.Public.html#funding_amount/1-parameters"},{"type":"function","title":"Geminex.API.Public.funding_amount_report/1","doc":"Retrieves the funding amount report file.","ref":"Geminex.API.Public.html#funding_amount_report/1"},{"type":"function","title":"Parameters - Geminex.API.Public.funding_amount_report/1","doc":"- **opts** (*keyword list, optional*): A list of query parameters to customize the report.\n    - **:fromDate** (*non_neg_integer()*): The start date for the report, represented as a Unix timestamp.\n    - **:toDate** (*non_neg_integer()*): The end date for the report, represented as a Unix timestamp.\n    - **:numRows** (*non_neg_integer()*): The maximum number of rows to retrieve in the report.","ref":"Geminex.API.Public.html#funding_amount_report/1-parameters"},{"type":"function","title":"Returns - Geminex.API.Public.funding_amount_report/1","doc":"- **{:ok, binary}** on success, containing the binary content of the report file.\n  - **{:error, any}** on failure, with an error reason.","ref":"Geminex.API.Public.html#funding_amount_report/1-returns"},{"type":"function","title":"Geminex.API.Public.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#get/3"},{"type":"function","title":"Geminex.API.Public.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#get!/3"},{"type":"function","title":"Geminex.API.Public.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#head/3"},{"type":"function","title":"Geminex.API.Public.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#head!/3"},{"type":"function","title":"Geminex.API.Public.network/1","doc":"Retrieves the associated network for a requested token.","ref":"Geminex.API.Public.html#network/1"},{"type":"function","title":"Parameters - Geminex.API.Public.network/1","doc":"- **token**: Token identifier (e.g., \"eth\").","ref":"Geminex.API.Public.html#network/1-parameters"},{"type":"function","title":"Geminex.API.Public.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#options/3"},{"type":"function","title":"Geminex.API.Public.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#options!/3"},{"type":"function","title":"Geminex.API.Public.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Public.html#patch/4"},{"type":"function","title":"Geminex.API.Public.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Public.html#patch!/4"},{"type":"function","title":"Geminex.API.Public.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Public.html#post/4"},{"type":"function","title":"Geminex.API.Public.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Public.html#post!/4"},{"type":"function","title":"Geminex.API.Public.price_feed/0","doc":"Retrieves the price feed for all trading pairs.","ref":"Geminex.API.Public.html#price_feed/0"},{"type":"function","title":"Geminex.API.Public.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Public.html#put/4"},{"type":"function","title":"Geminex.API.Public.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Geminex.API.Public.html#put!/4"},{"type":"function","title":"Geminex.API.Public.request/2","doc":"Perform a request.","ref":"Geminex.API.Public.html#request/2"},{"type":"function","title":"Options - Geminex.API.Public.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"Geminex.API.Public.html#request/2-options"},{"type":"function","title":"Examples - Geminex.API.Public.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"Geminex.API.Public.html#request/2-examples"},{"type":"function","title":"Geminex.API.Public.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"Geminex.API.Public.html#request!/2"},{"type":"function","title":"Geminex.API.Public.symbol_details/1","doc":"Retrieves extra detail on a supported symbol.","ref":"Geminex.API.Public.html#symbol_details/1"},{"type":"function","title":"Parameters - Geminex.API.Public.symbol_details/1","doc":"- **symbol**: Trading pair symbol (e.g., \"btcusd\").","ref":"Geminex.API.Public.html#symbol_details/1-parameters"},{"type":"function","title":"Geminex.API.Public.symbols/0","doc":"Retrieves all available symbols for trading.","ref":"Geminex.API.Public.html#symbols/0"},{"type":"function","title":"Geminex.API.Public.ticker/1","doc":"Retrieves information about recent trading activity for the symbol.","ref":"Geminex.API.Public.html#ticker/1"},{"type":"function","title":"Parameters - Geminex.API.Public.ticker/1","doc":"- **symbol**: Trading pair symbol (e.g., \"btcusd\").","ref":"Geminex.API.Public.html#ticker/1-parameters"},{"type":"function","title":"Geminex.API.Public.ticker_v2/1","doc":"Retrieves information about recent trading activity for the provided symbol (V2).","ref":"Geminex.API.Public.html#ticker_v2/1"},{"type":"function","title":"Parameters - Geminex.API.Public.ticker_v2/1","doc":"- **symbol**: Trading pair symbol (e.g., \"btcusd\").","ref":"Geminex.API.Public.html#ticker_v2/1-parameters"},{"type":"function","title":"Geminex.API.Public.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#trace/3"},{"type":"function","title":"Geminex.API.Public.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Geminex.API.Public.html#trace!/3"},{"type":"function","title":"Geminex.API.Public.trade_history/2","doc":"Retrieves the trade history for the specified trading pair symbol.","ref":"Geminex.API.Public.html#trade_history/2"},{"type":"function","title":"Parameters - Geminex.API.Public.trade_history/2","doc":"- **symbol** (*String.t()*): The trading pair symbol (e.g., **\"btcusd\"**).\n  - **opts** (*keyword list, optional*): A list of options to customize the query.\n    - **:timestamp** (*non_neg_integer()*): The starting timestamp for the trade history.\n    - **:since_tid** (*non_neg_integer()*): The trade ID from which to start fetching trades.\n    - **:limit_trades** (*non_neg_integer()*): The maximum number of trades to retrieve.\n    - **:include_breaks** (*boolean()*): Whether to include breaks between trades. Defaults to **false**.","ref":"Geminex.API.Public.html#trade_history/2-parameters"},{"type":"function","title":"Returns - Geminex.API.Public.trade_history/2","doc":"- **{:ok, list(map)}** on success, containing the trade history as a list of maps.\n  - **{:error, any}** on failure, with an error reason.","ref":"Geminex.API.Public.html#trade_history/2-returns"},{"type":"type","title":"Geminex.API.Public.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"Geminex.API.Public.html#t:option/0"},{"type":"module","title":"Geminex.Utils","doc":"Utility functions for handling common tasks within the Geminex library.\n\nThis module provides helper functions to manage payload transformations,\nhandle HTTP responses, and merge maps with keyword lists.","ref":"Geminex.Utils.html"},{"type":"function","title":"Geminex.Utils.handle_binary_response/1","doc":"","ref":"Geminex.Utils.html#handle_binary_response/1"},{"type":"function","title":"Geminex.Utils.handle_response/1","doc":"Handles HTTP responses by returning **{:ok, body}** for successful responses or **{:error, reason}** for failures.","ref":"Geminex.Utils.html#handle_response/1"},{"type":"function","title":"Parameters - Geminex.Utils.handle_response/1","doc":"- **response**: The HTTP response tuple returned by the Tesla client.","ref":"Geminex.Utils.html#handle_response/1-parameters"},{"type":"function","title":"Returns - Geminex.Utils.handle_response/1","doc":"- **{:ok, body}** if the HTTP status is in the 200–299 range.\n  - **{:error, %{status: status, body: body}}** if the status is outside of the success range.\n  - **{:error, reason}** if there is a client error.","ref":"Geminex.Utils.html#handle_response/1-returns"},{"type":"function","title":"Examples - Geminex.Utils.handle_response/1","doc":"iex> Utils.handle_response({:ok, %Tesla.Env{status: 200, body: %{\"result\" => \"success\"}}})\n    {:ok, %{\"result\" => \"success\"}}\n\n    iex> Utils.handle_response({:ok, %Tesla.Env{status: 400, body: %{\"error\" => \"invalid_request\"}}})\n    {:error, %{status: 400, body: %{\"error\" => \"invalid_request\"}}}\n\n    iex> Utils.handle_response({:error, :timeout})\n    {:error, :timeout}","ref":"Geminex.Utils.html#handle_response/1-examples"},{"type":"function","title":"Geminex.Utils.maybe_put/3","doc":"Conditionally adds a key-value pair to a map if the value is not **nil**.","ref":"Geminex.Utils.html#maybe_put/3"},{"type":"function","title":"Parameters - Geminex.Utils.maybe_put/3","doc":"- **map**: The original map to which the key-value pair may be added.\n  - **key**: The key to be added to the map.\n  - **value**: The value to be associated with the key. If this is **nil**, the key-value pair is not added.","ref":"Geminex.Utils.html#maybe_put/3-parameters"},{"type":"function","title":"Returns - Geminex.Utils.maybe_put/3","doc":"- The original map if **value** is **nil**, or a new map with the key-value pair added if **value** is not **nil**.","ref":"Geminex.Utils.html#maybe_put/3-returns"},{"type":"function","title":"Examples - Geminex.Utils.maybe_put/3","doc":"iex> Utils.maybe_put(%{\"a\" => 1}, \"b\", 2)\n    %{\"a\" => 1, \"b\" => 2}\n\n    iex> Utils.maybe_put(%{\"a\" => 1}, \"b\", nil)\n    %{\"a\" => 1}","ref":"Geminex.Utils.html#maybe_put/3-examples"},{"type":"function","title":"Geminex.Utils.merge_map_with_string_keys/2","doc":"Merges a map with a keyword list, ensuring all keys from the keyword list are converted to strings.","ref":"Geminex.Utils.html#merge_map_with_string_keys/2"},{"type":"function","title":"Parameters - Geminex.Utils.merge_map_with_string_keys/2","doc":"- **map**: The base map to merge into.\n  - **keyword_list**: A keyword list with atom keys that need to be converted to strings.","ref":"Geminex.Utils.html#merge_map_with_string_keys/2-parameters"},{"type":"function","title":"Returns - Geminex.Utils.merge_map_with_string_keys/2","doc":"- A new map with all keys from **keyword_list** as strings, merged into **map**.","ref":"Geminex.Utils.html#merge_map_with_string_keys/2-returns"},{"type":"function","title":"Examples - Geminex.Utils.merge_map_with_string_keys/2","doc":"iex> Utils.merge_map_with_string_keys(%{\"a\" => 1, \"b\" => 2}, [a: 10, c: 3])\n    %{\"a\" => 10, \"b\" => 2, \"c\" => 3}","ref":"Geminex.Utils.html#merge_map_with_string_keys/2-examples"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}